require 'csv'

class Hermes::Admin::RfrSettingsController < Hermes::Admin::BaseController
  before_action :authorize_users
  before_action :set_threshold, only: [:edit, :update, :destroy, :show]
  before_action :check_adminrole
  rescue_from JSON::ParserError, with: :invalid_json

  def index
    @setting = Setting.where(key: 'hermes_rfr_settings').first
    flash[:notice]  = nil 

    if params[:setting].present? && setting_params["values"].present?
      values = setting_params["values"]
      values["should_show_rfr_message"] = values["should_show_rfr_message"].to_s == "1" ? true : false
      if @setting.update_attributes(values: values)
        flash[:notice] = "Mise à jour effectuée"
      else
        flash[:devise] = @setting.errors.full_messages.to_sentence
      end
    end

    respond_to do |format|
      format.html
      format.js
    end
  end



  private

  def setting_params
    params.require(:setting).permit(values: [:change_minus_two_date, :change_minus_two_year, :should_show_rfr_message, :message_duration, :rfr_message_title, :rfr_message])
  end
end 