# frozen_string_literal: true

# checker Api::Dmo::HermesController avant d'ajouter des méthodes
module Hermes
  module Api
    module Dmo
      class LogsController < Hermes::Api::Dmo::ApplicationController

        class << self
          def mutate_params
            {

            }
          end 
      
          def acceptable_params
            {
              code: {type: 'String'},
              read_level: {type: 'String'},
              user_id: {type: 'String'},
              action: {type: 'String'},
              current_user_id: {type: 'String'},
              applicant_id: {type: 'String'},
              housing_offer_id: {type: 'String'},
              housing_request_id: {type: 'String'},
            }.merge(self.mutate_params).merge(super)
          end 
      
          def valid_operators
            %w[$in $nin $ne $gt $gte $lt $lte $regex]
          end
      
          def regex_params
            {
      
            }
          end 
        end

        def initialize
          super
          @serializer = Hermes::LogSerializer
          @model = Log
        end

        def index
          acceptable_params *self.class.acceptable_params.keys
          valid_operators *self.class.valid_operators
          paginate(index_aggregation, each_serializer: @serializer, **@options)
        end

        def housing_requests
          @query_precision ||= {}
          @query_precision = @query_precision.merge({ housing_request_id: { :$ne => nil } })
          index
        end

        def housing_offers
          @query_precision ||= {}
          @query_precision = @query_precision.merge({ housing_offer_id: { :$ne => nil } })
          index
        end

        def applicants
          @query_precision ||= {}
          @query_precision = @query_precision.merge({ applicant_id: { :$ne => nil } })
          index
        end

        def housing_applications
          @query_precision ||= {}
          @query_precision = @query_precision.merge({ housing_application_id: { :$ne => nil } })
          index
        end

        private

        def index_aggregation(target_model: @model, no_acl: false)
          return unless target_model

          precision = @query_precision || {}
          precision[:user_id] = params[:responsible] if params[:responsible]
          query = target_model
          query.where(build_query(target_model).deep_merge(precision)).order_by(order_params).includes(include_relationships)
        end
      end
    end
  end
end
