# frozen_string_literal: true

module Hermes
  class UserFilter
    include Hermes::Concerns::CommonFieldsConcern
    
    field :key, type: String
    field :value, type: Hash
    
    validates_presence_of :key
    validates_presence_of :user_id
    validates :key , uniqueness: { scope: :user_id }

    owner_field :user_id

    common_indexes *%i[
      key
      value
    ]

  end
end
